image: gradle:6.6.1-jdk11-hotspot

variables:
  DOCKER_DRIVER: overlay
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"
  GIT_DEPTH: "0"

stages:
  - build
  - test
  - visualize
  - package

gradle-build:
  stage: build
  script:
    - gradle assemble
  artifacts:
    expire_in: 1h
    paths:
      - build/libs/*.jar

docker-registry:
  image: docker:latest
  stage: package
  variables:
    APP_VERSION: 3.0.0
  services:
    - docker:dind
  script:
    - CONFIG_SERVER_IMAGE_NAME=${CI_REGISTRY_IMAGE}:${CI_COMMIT_BRANCH}-${APP_VERSION}-${CI_COMMIT_SHORT_SHA}
    - docker build -t $CONFIG_SERVER_IMAGE_NAME .
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker push $CONFIG_SERVER_IMAGE_NAME
  only:
    - staging
    - master

nginx-docker-registry:
  image: docker:latest
  stage: package
  variables:
    APP_VERSION: 3.0.0
  services:
    - docker:dind
  script:
    - APP_IMAGE_NAME=${CI_REGISTRY_IMAGE}/cuidemonos-nginx-proxy:${CI_COMMIT_BRANCH}-${APP_VERSION}-${CI_COMMIT_SHORT_SHA}
    - docker build -t $APP_IMAGE_NAME ./deploy/frontend/nginx
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker push $APP_IMAGE_NAME
  only:
    - master
  when: manual
